-- KillTheHealer.lua

-- Written by: Noctys (Anthony Nichols) 
-- Kill The Healer plays a sound when an enemy healer is targetted.
-- Requires LibTargetInfo

--  One plus One is never equal to Three... Even for very large values of One.

if KillTheHealer then return end
KillTheHealer = {}

 --------------------------------------
-- create 'session' variables
--------------------------------------- 
 KillTheHealer.lastTargetId = 0
 KillTheHealer.savedVars = nil
 --------------------------------------
-- Initilize and Shutdown Function
---------------------------------------
function KillTheHealer.Initialize()
	d("KillTheHealer is running")
	--Create the KillTheHealerHT (Hostile Target) window
	CreateWindow("KillTheHealerHT", true)	
	LayoutEditor.RegisterWindow( "KillTheHealerHT",
                                L"HostileTargetCareer(Type)",
                                L"Shows the career name and type of the hostile target.",
                                false, false,
                                true, nil )
	WindowSetShowing("KillTheHealerHTText", true)
	RegisterEventHandler(SystemData.Events.PLAYER_TARGET_UPDATED, "KillTheHealer.careerCheck")
	if (KillTheHealer.savedVars == nil) then
		KillTheHealer.savedVars = {}
		KillTheHealer.savedVars["targetType"] = {}
		KillTheHealer.savedVars["notifyAll"] = false
		KillTheHealer.savedVars["targetType"][1] = "Healer"
	end
	
	if (type(LibSlash) == "table") then
      LibSlash.RegisterSlashCmd("kthHelp",  function() KillTheHealer.help() end)
	  LibSlash.RegisterSlashCmd("kthealer", function() KillTheHealer.help() end)
	  LibSlash.RegisterSlashCmd("kthType",  function(input) KillTheHealer.setCareerType(input) end)
	  LibSlash.RegisterSlashCmd("kthAll",   function() KillTheHealer.toggleAll() end)
   end
   
   EA_ChatWindow.Print(L"Kill the healer loaded, type /KTHType for options(libSlash)")
end

function KillTheHealer.Shutdown()
	d("KillTheHealer is being shutdown")
	UnregisterEventHandler(SystemData.Events.PLAYER_TARGET_UPDATED, "KillTheHealer.careerCheck")
end

 --------------------------------------
-- Main Program 
---------------------------------------

function KillTheHealer.careerCheck(targetClassification, targetId, targetType)
	--targetType 5 is an enemy player, so we don't want to do anything unless  that's what it is
	--also if targetClassification is not "selfhostiletarget" we don't want to do anything
	--lastly if it is the target we are already targetting we don't need to update (event called when something about target changes too)
	if (targetType == 5 and targetClassification == "selfhostiletarget" and KillTheHealer.lastTargetId ~= targetId) then
		TargetInfo:UpdateFromClient()
		KillTheHealer.lastTargetId = targetId
		local targetCareerName = LibTargetInfo.career(targetClassification)
		local targetCareerType = LibTargetInfo.typeNoUpdate(targetClassification)
		--d("targetCareerType is being returned as: "..type(targetCareerType))
		if (targetCareerType == KillTheHealer.savedVars["targetType"][1]) then
			PlaySound(217)
			--EA_ChatWindow.Print(towstring(targetCareerType)..L"!!!")
			AlertTextWindow.AddLine(SystemData.AlertText.Types.QUEST_END, towstring(targetCareerType))
			--d("Healer Found!!!")
		elseif(KillTheHealer.savedVars["notifyAll"]) then
			--EA_ChatWindow.Print(towstring(targetCareerType)..L"!!!")
			AlertTextWindow.AddLine(SystemData.AlertText.Types.QUEST_CONDITION, towstring(targetCareerType))
		end
		
		if (targetCareerName ~= "unknown career") then
			--d(targetCareerName)
			LabelSetText("KillTheHealerHTText", towstring(targetCareerName)..L"("..towstring(targetCareerType)..L")")
			if (targetCareerType == "Healer") then
				LabelSetTextColor("KillTheHealerHTText", 3,192,60)
			elseif (targetCareerType == "Ranged") then
				LabelSetTextColor("KillTheHealerHTText", 185,78,72)
			elseif (targetCareerType == "Melee") then
				LabelSetTextColor("KillTheHealerHTText", 228,155,15)
			elseif (targetCareerType == "Tank") then
				LabelSetTextColor("KillTheHealerHTText", 128,0,128)
			else
				LabelSetTextColor("KillTheHealerHTText", 125,125,125)
			end
		else
			LabelSetTextColor("KillTheHealerHTText", 125,125,125)
		end
		WindowSetShowing("KillTheHealerHTText", true)
		
	elseif (targetType ~= 5 and targetClassification == "selfhostiletarget" and KillTheHealer.lastTargetId ~= targetId) then
		KillTheHealer.lastTargetId = targetId
		WindowSetShowing("KillTheHealerHTText", false)
	end
end


---------------------
-- LibSlash Functions
---------------------

function KillTheHealer.setCareerType(newTargetType)
	if (newTargetType == "Healer" or newTargetType == "Ranged" or newTargetType == "Melee" or newTargetType == "Tank") then
		KillTheHealer.savedVars["targetType"][1] = newTargetType
		EA_ChatWindow.Print(L"Kill The Healer is now Kill The "..towstring(newTargetType)..L"!")
	else
		EA_ChatWindow.Print(L"Target type must be Healer, Ranged, Melee or Tank, case-sensitive")
	end
end

function KillTheHealer.toggleAll()
	if (KillTheHealer.savedVars["notifyAll"]) then
		KillTheHealer.savedVars["notifyAll"] = false
		EA_ChatWindow.Print(L"Kill The Healer will now only report your selected target type.")
	else
		KillTheHealer.savedVars["notifyAll"] = true
		EA_ChatWindow.Print(L"Kill The Healer will now report all target types.")
	end
end

function KillTheHealer.help()
		EA_ChatWindow.Print(L"Use /kthType with Healer, Ranged, Melee or Tank (case-sensitive) to change what target type if notifies on")
		EA_ChatWindow.Print(L"use /kthAll to toggle text notification on and off for all target types.")
end